import { test } from "node:test";
import * as engine from "./ssr.ts";

test("sanity", (t) => t.assert.equal(engine.ssrSync("gm <3").text, "gm &lt;3"));
test("simple tree", (t) =>
  t.assert.equal(
    engine.ssrSync(
      <main class={["a", "b"]}>
        <h1 style="background-color:red">hello world</h1>
        <p>haha</p>
        {1}|
        {0}|
        {true}|
        {false}|
        {null}|
        {undefined}|
      </main>,
    ).text,
    '<main class="a b"><h1 style=background-color:red>hello world</h1><p>haha</p>1|0|||||</main>',
  ));
